• 一文搞定Python中的异常处理
  • 发布于 2个月前
  • 394 热度
    0 评论
我们在编码或者做产品的时候,不仅要考虑正向的,还要考虑到异常情况下如何处理。人生也是如此,成功的时候要考虑落败时,这样考虑问题就全面,周全。

如果我们能提前预判到可能出现的各种状况,那么我们就可以做相对应的措施来挽救。

调试Python程序时,经常会报出一些异常,不管我们是启动程序,或者调用接口,总不是100%的成功,异常的原因一方面可能是写程序时由于疏忽或者考虑不全造成了错误,这时就需要根据异常Traceback到出错点,进行分析改正;另一方面,有些异常是不可避免的,但我们可以对异常进行捕获处理,防止程序终止。
python 中的try...except就是这个原理。

出现了异常,我们如果能捕捉到,那是最好不过了。

异常捕获

当发生异常时,我们就需要对异常进行捕获,然后进行相应的处理。python的异常捕获常用try...except...结构,把可能发生错误的语句放在try模块里,用except来处理异常,每一个try,都必须至少对应一个except。此外,与python异常相关的关键字主要有:

关键字 关键字说明
try/except  捕获异常并处理
pass    忽略异常
as  定义异常实例(except MyError as e)
else    如果try中的语句没有引发异常,则执行else中的语句
finally 无论是否出现异常,都执行的代码
raise       抛出/引发异常
捕捉所有异常:
try:
     <语句>
except:
      print('异常说明')

捕捉指定异常
try:
     <语句>
except <异常名>:
      print('异常说明')

万能异常:
try:
     <语句>
except Exception:
      print('异常说明')

捕获多个异常,不分优先级
try:
     <语句>
except (<异常名1>, <异常名2>, ...):
      print('异常说明')

捕获多个异常,区分优先级
try:
     <语句>
except <异常名1>:
      print('异常说明1')
except <异常名2>:
      print('异常说明2')
except <异常名3>:
      print('异常说明3')

该种异常处理语法的规则是:
执行try下的语句,如果引发异常,则执行过程会跳到第一个except语句。
如果第一个except中定义的异常与引发的异常匹配,则执行该except中的语句。
如果引发的异常不匹配第一个except,则会搜索第二个except,允许编写的except数量没有限制。
如果所有的except都不匹配,则异常会传递到下一个调用本代码的最高层try代码中。

异常中的else

如果判断完没有某些异常之后还想做其他事,就可以使用下面这样的else语句。
try:
     <语句>
 
except <异常名1>:
 
      print('异常说明1')
 
except <异常名2>:
 
      print('异常说明2')
 
else:
 
      <语句>  # try语句中没有异常则执行此段代码

异常中的finally

try...finally...语句无论是否发生异常都将会执行最后的代码。
str1 = 'hello world'
try:
    int(str1)
except IndexError as e:
    print(e)
except KeyError as e:
    print(e)
except ValueError as e:
    print(e)
else:
    print('try内没有异常')
finally:
  print('无论异常与否,都会执行我')

raise主动触发异常
可以使用raise语句自己触发异常,raise语法格式如下:

raise [Exception [, args [, traceback]]]
看一个例子:
def not_zero(num):
    try:
        if num == 0:
            raise ValueError('参数错误')
        return num
    except Exception as e:
        print(e)
not_zero(0)

采用traceback模块查看异常

Python还维护着traceback(跟踪)对象,其中含有异常发生时与函数调用堆栈有关的信息。
格式如下:

try:
    block

except:
    traceback.print_exc()
我们如何得到出错信息呢?
1、str(e)
返回字符串类型,只给出异常信息,不包括异常信息的类型,如1/0的异常信息

'integer division or modulo by zero'

2、repr(e)
给出较全的异常信息,包括异常信息的类型,如1/0的异常信息

"ZeroDivisionError('integer division or modulo by zero',)"

3、采用traceback模块
需要导入traceback模块,此时获取的信息最全,与python命令行运行程序出现错误信息一致。使用traceback.print_exc()打印异常信息到标准错误,就像没有获取一样,或者使用traceback.format_exc()将同样的输出获取为字符串。你可以向这些函数传递各种各样的参数来限制输出,或者重新打印到像文件类型的对象。
例如:
import traceback

print('########################################################')
print("1/0 Exception Info")
print('---------------------------------------------------------')
try:
    1/0
except Exception as e:
    print('str(Exception):\t', str(Exception))
    print('str(e):\t\t', str(e))
    print('repr(e):\t', repr(e))

    print('traceback.print_exc():',traceback.print_exc())
    print('traceback.format_exc():\n%s' % traceback.format_exc())

另外,traceback.print_exc()跟traceback.format_exc()有什么区别呢?

区别就是,format_exc()返回字符串,print_exc()则直接给打印出来。即traceback.print_exc()与print(traceback.format_exc())效果是一样的。print_exc()还可以接受file参数直接写入到一个文件。比如可以像下面这样把相关信息写入到tb.txt文件去。

traceback.print_exc(file=open('tb.txt','w+'))

我们如何知道有哪些exception类型呢?
可以去官网上看一下:Exception类型
东西很多,这里只截取了一部分

BaseException  # 所有异常的基类
 +-- SystemExit  # 解释器请求退出
 +-- KeyboardInterrupt  # 用户中断执行(通常是输入^C)
 +-- GeneratorExit  # 生成器(generator)发生异常来通知退出
 +-- Exception  # 常规异常的基类
      +-- StopIteration  # 迭代器没有更多的值
      +-- StopAsyncIteration  # 必须通过异步迭代器对象的__anext__()方法引发以停止迭代
      +-- ArithmeticError  # 各种算术错误引发的内置异常的基类
      |    +-- FloatingPointError  # 浮点计算错误
      |    +-- OverflowError  # 数值运算结果太大无法表示
      |    +-- ZeroDivisionError  # 除(或取模)零 (所有数据类型)
      +-- AssertionError  # 当assert语句失败时引发
      +-- AttributeError  # 属性引用或赋值失败
      +-- BufferError  # 无法执行与缓冲区相关的操作时引发
      +-- EOFError  # 当input()函数在没有读取任何数据的情况下达到文件结束条件(EOF)时引发
      +-- ImportError  # 导入模块/对象失败
      |    +-- ModuleNotFoundError  # 无法找到模块或在在sys.modules中找到None
搞清楚python中的异常机制,代码的健壮性就强大很多,而且可以更快的定位和分析各种异常。

代码中加入各种异常处理,就相当于买了保险,程序再也不容易崩溃了!
用户评论